Installation
============

There are two ways to use AlphaD3M: 1) via Docker/Singularity containers, and 2) via PyPI installation.

Docker/Singularity containers
------------------------------
This version works with Python 3.6 through 3.8 in Linux and Mac. It supports all the ML tasks and data types
mentioned :doc:`here <how-works>`. You need to have Docker or Singularity installed on your operating system.
In this version, a container runs in the background, but AlphaD3M continues to be used as a standard Python library.

To install, run:

::

   $ pip install alphad3m-containers

Once the installation is completed, you need to pull manually the Docker image of AlphaD3M.

For Docker:
::

   $ docker pull registry.gitlab.com/vida-nyu/d3m/alphad3m:latest

or for Singularity:

::

   $ singularity pull docker://registry.gitlab.com/vida-nyu/d3m/alphad3m:latest

PyPI
-----
Currently, this version has supports all the ML tasks and data types mentioned :doc:`here <how-works>`. (using a limited
set of primitives). This package works with Python 3.8 in Linux and Mac.
Installation will require a version of `pip >= 20.3` to leverage the improved dependency resolver, as lower versions may
raise dependency conflicts. You might need GCC or other C/C++ compilers to install packages like NumPy, which uses C
extensions.

To install, run these commands:

::

   $ pip install alphad3m
   $ pip install d3m-common-primitives d3m-sklearn-wrap dsbox-corex dsbox-primitives sri-d3m distil-primitives rpi-d3m-primitives kf-d3m-primitives autonbox lupi-mfa d3m-jhu-primitives fastlvm d3m-esrnn d3m-nbeats --no-binary pmdarima


The second command installs the primitives available on PyPI.

|:warning:| WARNING |:warning:|

On non-Linux platforms:

- You will need `swig` to compile pyrfr. You can obtain swig from
  `homebrew <https://formulae.brew.sh/formula/swig@3>`__, `anaconda <https://anaconda.org/anaconda/swig>`__, or
  `the swig website <http://www.swig.org/download.html>`__.
- To install fastlvm primitives on Mac, run:

  ::

     CFLAGS=-mmacosx-version-min=10.12 CXXFLAGS=-mmacosx-version-min=10.12 python -m pip install fastlvm
